import { world } from "@minecraft/server";
import { ActionFormData, ModalFormData } from "@minecraft/server-ui";
import { splitBody } from "./main";

function settingsForm(player) {
    const form = new ActionFormData();
    form.title("Split Body Settings")
    form.button("Swap Interval")
    form.button("Toggle Swap Interval")
    form.button("Clear Split Bodies")
    form.show(player).then(result => {
        const button = result.selection;

        if (button === 0) {
            const swapInterval = new ModalFormData();
            swapInterval.title("Split Body Settings")
            swapInterval.slider("interval in seconds", 1, 60, 1, 10)
            swapInterval.show(player).then(result => {
                const input = result.formValues;
                world.setDynamicProperty("split:interval", input[0])
                player.sendMessage(`§eSwap interval has been set to ${input[0]} seconds!`)
            })
        }

        if (button === 1) {
            if (world.getDynamicProperty("split:toggle") === false) {
                player.sendMessage(`§eSwap has been enabled!`)
                world.setDynamicProperty("split:toggle", undefined)
            }else {
                player.sendMessage(`§eSwap has been turned disabled!`)
                world.setDynamicProperty("split:toggle", false)
            }
        }

        if (button === 2) {
            player.sendMessage(`§eSplit Bodies has been cleared!`)
            const players = world.getPlayers();
            for (let player of players) {
                player.setDynamicProperty("split:location", undefined)
                player.setDynamicProperty("split:rotation", undefined)
                player.setDynamicProperty("split:timer", undefined)
            }
        }
    })
}



world.afterEvents.itemCompleteUse.subscribe(event => {
    const { itemStack, source } = event;
    
    // split Settings Item
    if (itemStack?.typeId == "split:settings") {
        settingsForm(source)
    }
    
    // Force split Item
    if (itemStack?.typeId == "split:force") {
        source.startItemCooldown("split:force", 5)
        
        const players = world.getPlayers();
        for (let player of players) {
            player.setDynamicProperty("split:timer", undefined)
            splitBody(player, true)
        }
    }
    
    // Self split Item
    if (itemStack?.typeId == "split:self") {
        source.startItemCooldown("split:self", 5)
        source.setDynamicProperty("split:timer", undefined)
        splitBody(source, true)
    }
})
