import { world, system } from "@minecraft/server";



function splitBodyParticle(player) {
    const splitLocation = player.getDynamicProperty("split:location");

    player.dimension.spawnParticle?.("split:drop", splitLocation)
    player.dimension.spawnParticle?.("split:sparkle", splitLocation)
    if (Math.floor(Math.random()*16) == 0) {
        player.dimension.spawnParticle?.("split:split_body_spook", splitLocation)
    }else player.dimension.spawnParticle?.("split:split_body", splitLocation);
}



export function splitBody(player, swap) {
    const splitLocation = player.getDynamicProperty("split:location");
    const splitRotation = player.getDynamicProperty("split:rotation");
    if (swap !== true) {
        
        function vec2ToVec3(vec2) {
            return {
                x: vec2.x,
                y: vec2.y,
                z: 0
            }
        }

        player.setDynamicProperty("split:location", player.location)
        player.setDynamicProperty("split:rotation", vec2ToVec3(player.getRotation()))
    }else {
        player.dimension.playSound("mob.endermen.portal", player.location)
        splitBody(player)
        if (splitLocation && splitRotation) {
            system.run(() => {
                player.teleport(splitLocation, {rotation: {
                    x: splitRotation.x,
                    y: splitRotation.y
                }})
                player.dimension.playSound("mob.endermen.portal", player.location)
            })
        }
    }
}



const runSplit = system.runInterval(() => {
    const players = world.getPlayers();
    for (let player of players) {
        const splitLocation = player.getDynamicProperty("split:location");
        const splitTimer = player.getDynamicProperty("split:timer");
        const splitInterval = world.getDynamicProperty("split:interval");

        if (world.getDynamicProperty("split:toggle") !== false) {
            const splitIntervalDefault = 10;

            if (splitTimer === undefined) {
                if (splitInterval === undefined) {
                    player.setDynamicProperty("split:timer", splitIntervalDefault)
                }else player.setDynamicProperty("split:timer", splitInterval);
            }else if (splitTimer > 1) {
                player.setDynamicProperty("split:timer", splitTimer-1)
            }else {
                player.setDynamicProperty("split:timer", undefined)
                splitBody(player, true)
            }
        }

        if (splitLocation) {
            splitBodyParticle(player);
        }else if (world.getDynamicProperty("split:toggle") !== false) splitBody(player);
    }
}, 20)